// NJSC5.00 2008-11 Eduard Sanosian
// SAN Business Solutions, The Netherlands, www.sanbs.nl
// E-mail: info@sanbs.nl
// Functions verifySupport and XML2JS are borrowed from D.Goodman's book JavaScript&DHTML.Cookbook.

var xDoc, rawData, output = new Array(),folder;
var i, j, oneRecord, oneObject;
var result = "", Property = "";
var xRows = 1, xColumns = 1, xPos = 1;
var currID, currPos, rowNo, colNo; 
var dragObj, dragObjID, divID, changed ;
var sourceCell, destCell;
var imgOption = new Array('Black','Blue','Green','Yellow','Red'); imgFile = new Array(); imgObj = new Array(); cList = '';

function getNewRowCol(cell_ID) {
    var StrIndex;
    StrIndex = cell_ID.indexOf('-');
    rowNo = parseInt(cell_ID.substring(0,StrIndex));
    colNo = parseInt(cell_ID.substring(StrIndex+1,cell_ID.length));
}

function drag(e)  {
    var cX = event.clientX, cY = event.clientY, oLeft = myTab.offsetLeft, oTop = myTab.offsetTop;
    dragObj = e;
    e.style.position = "absolute";
    if (cX > oLeft && cX < oLeft+myTab.offsetWidth && cY > oTop  && cY < oTop+myTab.offsetHeight) {
        e.style.posLeft = cX - e.parentElement.offsetWidth/2;
        e.style.posTop = cY - e.parentElement.offsetHeight/2;
    }
    sourceCell = e.parentElement;
    dragObjID = e.id;
}

function dragEnd(e) {
    var cX = event.clientX, cY = event.clientY, oLeft = myTab.offsetLeft, oTop = myTab.offsetTop;   
    for (var i=0; i < myTab.cells.length; i++) {
        if (cX - oLeft >= myTab.cells[i].offsetLeft && cX -oLeft < myTab.cells[i].offsetLeft+myTab.cells[i].offsetWidth &&
            cY - oTop >= myTab.cells[i].offsetTop  && cY - oTop < myTab.cells[i].offsetTop+myTab.cells[i].offsetHeight) {
            currID =  myTab.cells[i].id;
            break
        }          
    } 
    destCell = document.getElementById(currID);
    sourceCell.removeChild(dragObj);
    destCell.appendChild(dragObj);
    dragObj.style.position = "fixed";
    dragObj.style.posTop = 0;
    if (!sourceCell.hasChildNodes()) {
        sourceCell.innerHTML = '&nbsp;';
    }
    transData();
} 

function transData() { 
    var NewPos = 0;
    getNewRowCol(destCell.id);  
    for (i = 0; i < destCell.childNodes.length; i++) {
        if (destCell.childNodes[i].nodeType == 1)  {
            NewPos ++;
        }   
    }  
    for (var z = 0; z < output.length; z++) {
        if (output[z].id == dragObjID) {
            output[z].RowNo = rowNo;
            output[z].ColumnNo = colNo;
            output[z].Position = NewPos;
            output[z].EntryNo = NewPos;
            changeDOM(output[z],z); 
            renumSourceCellPos();   
            break
        }
    }
} 
 
function renumSourceCellPos() {   
    var NewPos = 0; 
    for (i = 0; i < sourceCell.childNodes.length; i++) {
        if (sourceCell.childNodes[i].nodeType == 1)  {
            NewPos ++; 
            divID = sourceCell.childNodes[i].id;
            for (var z = 0; z < output.length; z++) {
                if (output[z].id == divID && output[z].EntryNo != NewPos) { 
                    output[z].Position = NewPos;
                    output[z].EntryNo = NewPos;
                    changeDOM(output[z],z);
                }  
            }
        }   
    }     
} 

// verify that browser supports XML features and load external .xml file
function verifySupport(xFile) {
    if (document.implementation && document.implementation.createDocument) {
        // this is the W3C DOM way, supported so far only in NN6+
        xDoc = document.implementation.createDocument("", "theXdoc", null);
    } else if (typeof ActiveXObject != "undefined") {
        // make sure real object is supported (sorry, IE5/Mac)
        if (document.getElementById("msxml").async) {
            xDoc = new ActiveXObject("Msxml.DOMDocument");
        }
    }
    if (xDoc && typeof xDoc.load != "undefined") {
        // load external file (from same domain)
        xDoc.load(xFile);
        return true;
    } else {
        var reply = confirm("This example requires a browser with XML support, " +
            "such as IE5+/Windows or Netscape 6+.\n \nGo back to previous page?");
        if (reply) {
            history.back();
        }
    }
    return false;
}

function init(xFile) {
    // initialize 
    if (verifySupport(xFile)) {
        XML2JS(xFile,'MonkeyCompany');
        listProperties(output[0],'output');
        initIMG();
        addText('The Monkey Company',true,true,true);
        addButton();
        createTable();
        addText('Drag and Drop the image from one cell to another cell. You can also change the Name, Job Title and Color.',true,false,false);
        addText('Leave this web page on your desktop during the lunch break. It will make a big impression on your boss.',true,false,false);
    }
}

function XML2JS(xmlDoc, containerTag) {
    // convert XML data into JavaScript objects
    rawData = xDoc.getElementsByTagName(containerTag)[0];
    folder = rawData.attributes[0].nodeValue;
    for (i = 0; i < rawData.childNodes.length; i++) {
        if (rawData.childNodes[i].nodeType == 1) {
            oneRecord = rawData.childNodes[i];
            oneObject = output[output.length] = new Object();
            for (j = 0; j < oneRecord.childNodes.length; j++) {
                if (oneRecord.childNodes[j].nodeType == 1) {
                    oneObject[oneRecord.childNodes[j].tagName] = 
                        oneRecord.childNodes[j].firstChild.nodeValue;     
                }
            }
            oneObject["id"] = oneRecord.childNodes[0].firstChild.nodeValue + '-' +
                              oneRecord.childNodes[1].firstChild.nodeValue + '-' +
                              oneRecord.childNodes[2].firstChild.nodeValue;
        }
    }
    return output;
}

function listProperties(obj, objName) {
    for (var i in obj) {
      result += objName + "." + i + "=" + obj[i] + "\n";
      Property += i +"\n";
    }
}

function addText(txt,align,bold,heading) {
    var elem;
    if (heading)  {
        elem = document.createElement('h1');
    }  else  {        
        elem = document.createElement('p');
    }    
    if (align)  {
        elem.align = 'center';
    }
    if (bold)  {    
        elem.style.fontWeight= 'bold';
    }     
    var tNode = document.createTextNode(txt);
    elem.appendChild(tNode);
    document.body.appendChild(elem);
}

function addButton()  {
    var strButton = '<p align="center">&nbsp;<button id="B1" onclick = "writeXML()" style = "border:1px outset #FFFFFF; visibility:hidden;'
    strButton +=  'background-color:#FFFFFF";>Save</button>';
    document.body.innerHTML += strButton;
}

function showButton(toShow)  {
    if (toShow)  {
        document.all.B1.style.visibility="visible";  
    }  else  {
        document.all.B1.style.visibility="hidden"; 
    } 
}

function changeDOM(obj,recIndex)  {
    j = 0
    try {
        for (var i in obj) {
            rawData.childNodes[recIndex].childNodes[j].firstChild.nodeValue = obj[i] 
            j++;
        } 
    }catch (err) {
    } 
    xDoc.safe;  
    changed = true;
    showButton(true);
}

function writeXML()  {
    var fso, fld, f, ts, forWriting  = 2, tristateTrue = -1;
    if (changed) {
        changed = false;
        showButton(false); 
        fso = new ActiveXObject("Scripting.FileSystemObject");
        fld = fso.GetFolder(folder); 
        fld.CreateTextFile("MonkeyCompany.xml",true,true);
        f = fso.GetFile(folder + "MonkeyCompany.xml");
        ts = f.OpenAsTextStream(forWriting,tristateTrue);
        ts.WriteLine(xDoc.xml);
        try {
            ts.Close();
        } 
        catch (err) {
        }
    }    
}

function createTable()  {
    var valueExist, srcIMG;   
    var strTable = document.body.innerHTML + '<div align="center"><TABLE id="myTab" border="1">';
    for (i = 0; i < output.length; i++) {
        if (output[i].RowNo > xRows) {
            xRows = output[i].RowNo;
        }
        if (output[i].ColumnNo > xColumns) {
            xColumns = output[i].ColumnNo;
        }
        if (output[i].EntryNo > xPos) {
            xPos = output[i].EntryNo;
        }
    } 
    xRows++;
    xColumns++;
    // Rows
    for (i=1; i<= xRows; i++)  {
        strTable += "<TR>";
        // Columns
        for (j=1; j<= xColumns; j++) {
            valueExist = false;
            strTable += '<td id= "' ;  
            strTable += +i + '-' + j + '" ' + ' width="120" height="100" align="left" valign="top"> ';
            for (var k=1; k<= xPos; k++) {
               for (var z = 0; z < output.length; z++) {
                   if ((output[z].RowNo == i) && (output[z].ColumnNo == j) && (output[z].EntryNo == k)){
                       strTable += '<div id="' + i + '-' + j + '-' + k +'" '+ 'ondrag = "drag(this)" ondragend = "dragEnd(this)"  align="left" valign="top">';
                       strTable += '<INPUT onchange= "changeAttribute(this,true)" SIZE="16" maxlength = "50" value="' + output[z].Name + '" style="font-style:italic">\n'; 
                       strTable += '<INPUT onchange= "changeAttribute(this,false)" SIZE="16" maxlength = "50" value="' + output[z].JobTitle + '">\n';
                       for (var n=0; n < imgOption.length; n++)  {
                           if (imgOption[n] == output[z].Hat)  {
                               srcIMG = imgFile[n];
                           }
                       }    
                       strTable += '<img border="0" src="';
                       strTable += srcIMG + '"  width="46" height="54">&nbsp;&nbsp;';
                       createSELECT(output[z].Hat);
                       strTable += cList;
                       strTable += '</div>';
                       valueExist =true;
                   } 
               }
            }
            if (!valueExist) {
                strTable += "&nbsp;</td>";
            }
            else {
                strTable += '</td>';
            }
        }
        strTable += "<TR>";
    }
    strTable += "</TABLE></div>";
    document.body.innerHTML = strTable;
}
function initIMG()  {
    for (var i=0; i < imgOption.length; i++)  {
        imgFile[i] = imgOption[i] + 'Mnk.gif';
    }  
    for (i=0; i < imgFile.length; i++)  {
        imgObj[i] = new Image(46,54);
        imgObj[i].src = imgFile[i];
    }  
}
function createSELECT(opt)  {
    var i,j;
    cList = '<SELECT onchange = "changeIMG(this.parentNode.id,this)" style = "width:60; font-size:8pt; height:19">';
    for (i=0; i < imgFile.length; i++)  { 
        var j = i + 1;
        if (opt == imgOption[i])  {
            cList += '<OPTION VALUE="' + j +'" SELECTED>' + imgOption[i] ;
        }  else {
            cList += '<OPTION VALUE= "' + j +'">' + imgOption[i];
        }    
    }  
    cList += '</SELECT>';
}
function changeIMG(pID,list)  {
    var slcIndex = list.options[list.selectedIndex].value-1;
    var eDiv = document.getElementById(pID);
        for (i=0; i<= eDiv.childNodes.length; i++)  {
        var chNode = eDiv.childNodes[i];
        if (typeof chNode != "undefined") {
            if (chNode.nodeType == 1 && chNode.tagName == 'IMG')  {
                chNode.src = imgFile[slcIndex];      
                for (var z = 0; z < output.length; z++) {
                    if (output[z].id == pID) {
                        output[z].Hat = imgOption[slcIndex];
                        changeDOM(output[z],z);
                    }  
                }
            } 
        }   
    }
}
function changeAttribute(e,flag) {
    divID = e.parentElement.id; 
    for (var z = 0; z < output.length; z++) {
        if (output[z].id == divID) { 
            if (output[z].Name != e.value && flag) { 
                output[z].Name = e.value;
            }
            if (output[z].JobTitle != e.value &&!flag) { 
                output[z].JobTitle = e.value;
            }  
            changeDOM(output[z],z); 
        }   
    }        
}

